# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""


from qgis.core import *
from qgis.gui import *
from Mapa_PU.model.konfiguracja import Projekt
from Mapa_PU.model.baza_danych import Baza
from Mapa_PU.widok.etykietuj_obiekty_liniowe import EtykietujObiektyLinioweOkno

from PyQt5.QtCore import * 

from Mapa_PU.kontroler.mapa import Mapa

from Mapa_PU.kontroler.etykietowanie import Etykiety

from PyQt5.QtGui import *
from Mapa_PU.kontroler import komunikaty
NAZWA_WARSTWY='LINIE'
ATRYBUTY=('KOD','SZER')

class ObiektyLiniowe(Etykiety):
    """Etykietowanie obiektów liniowych"""
    #Marcin Śliwa
 
        
    def __init__(self,iface,projekt,Mapa):
        """Konstruktor"""
        Etykiety.__init__(self,Mapa,iface,NAZWA_WARSTWY,ATRYBUTY,3,self.zmianaNarzedzia)
        
        self.iface=iface
        
        
        self.__projekt=projekt
        self.__mapa=Mapa
        
        self.__kod=None
        self.__szerokosc=None
        
    def __wczytaj_widok(self):
        """Wczytuje widok"""
        try:
            self.__okno=EtykietujObiektyLinioweOkno(self.iface.mainWindow())
                        
            self.__okno.zamknij=self.odlacz_wybor
            self.__okno.aktualizujWartosci=self.aktualizujWartosci
            
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def zmianaNarzedzia(self):
        """Wywoływane w trakcie zmiany narzędzia na mapie"""
        try:
            self.__okno.startEdycji()
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def etykietuj(self):
        """Wykonuje etykietowanie"""
        try:
            #Kontrola istnienia warstwy
            if self.kontroluj_warstwy(NAZWA_WARSTWY)==False:
                return
            self.ustaw_warstwe()
            if self.kontroluj_atrybuty(self.warstwa, ATRYBUTY)==False:
                return
                
                   
            
            self.ustaw_metode_koncowa(self.metoda_koncowa)
            
            self.__wczytaj_widok()
            #Podpi�cie metodya wyboru wiersza
            self.__okno.metoda=self.wybierz
            
            #
            self.__okno.show()
         
            
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def wybierz(self,kod,szerokosc):
        """Aktualizuje obiekt
        :param kod:kod aktualizacji
        :param szerokosc: szerokośc
        """
        try:
            self.aktualizujWartosci(kod, szerokosc)
                        
            #Sprawdzic dostepnosc warstwy O_PODST
            if self.kontroluj_warstwy(NAZWA_WARSTWY)==False:
                return
            self.ustaw_warstwe()
            if self.kontroluj_atrybuty(self.warstwa, ATRYBUTY)==False:
                return 
            
            self.podlacz_wybor()
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def metoda_koncowa(self):
        """Medoda wykonywana po wpisaniu wartości do obiektu"""
        try:
            self.__okno.startEdycji()
        except Exception as e:
            komunikaty.blad_systemowy(e)
      
    def aktualizujWartosci(self,kod,szerokosc):
        """Aktualizuje wartosci do wpisania"""
        try:
                        
            wartosci={ self.warstwa.idxPola('KOD')  : kod,
                        self.warstwa.idxPola('SZER') :szerokosc
                            }
            self.ustaw_wartosci(wartosci)
        except Exception as e:
            komunikaty.blad_systemowy(e)
            
    
    
    
    
        
    